(* ----------------------------------------------------- *)
(*                     SCROBJ.PAS                        *)
(*                                                       *)
(*   ScrObj schreibt direkt in den Bildschirmspeicher.  *)
(*    Die Anfangsadresse des Bildschirmspeichers wird    *)
(*    in Init festgelegt. Wer in einem erweiterten       *)
(*    Textmodus (zB 80x43) arbeitet, muss die Parameter  *)
(*    XL und YL an Init entsprechend bergeben.          *)
(*    Fr die Werte 0,0 wird die Standardauflsung 80x25 *)
(*    eingesetzt.                                        *)
(*                                                       *)
(*              (c) 1991 by R.Reichert                   *)
(* ----------------------------------------------------- *)
UNIT ScrObj;

INTERFACE

USES VSObj;

VAR
  ScrType : BYTE ABSOLUTE $0040:$0049;

TYPE
  ScreenObjPtr = ^ScreenObj;
  ScreenObj    = OBJECT (VirtualScreen)
    CONSTRUCTOR Init (XL, YL : BYTE);
    DESTRUCTOR Done;                               VIRTUAL;
  END;

IMPLEMENTATION

CONSTRUCTOR ScreenObj.Init (XL, YL : BYTE);
BEGIN
  IF (XL=0) OR (YL=0) THEN BEGIN
    XL := 80;  YL := 25;
  END;
  XLength := XL;  YLength := YL;
  ReturnCode := VSOk;
  IF ScrType=7 THEN VSMem := Ptr ($B000, $0000)
               ELSE VSMem := Ptr ($B800, $0000);
END;

DESTRUCTOR ScreenObj.Done;
BEGIN
  { kein Speicher freizugeben }
END;

END.
(* ----------------------------------------------------- *)
(*                  Ende von SCROBJ.PAS                  *)
(* ----------------------------------------------------- *)
